/*
 * 11/11/2001 - 17:58:01
 *
 * coord.java - permet de la la gestion d'une coodonne gographique
 * Copyright (C) 2001 C. Mercier
 * c.avmdti@free.fr
 * www.avmdti.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/**
 * Titre : QRA LOCATOR<p>
 * Description : outil de calcul pour le QRA locator<p>
 * Copyright : Copyright (c) C. Mercier<p>
 * Socit : www.avmdti.org<p>
 * @author C. Mercier
 * @version 1.0
 */
package org.avmdti.qralocator;

public class coord {

        public double _longitude;
        public int _long_degre, _long_minute, _long_seconde;
        public int _lat_degre, _lat_minute, _lat_seconde;
        public double _latitude;
        /**
        * constructeur avec degr minute seconde
        * @param=lon_degree ... longitude
        * @param=lat_degree ... latitude
        **/

        public coord (int long_degre, int long_minute,
                int long_seconde, int lat_degre, int lat_minute,
                int lat_seconde) {
                int signe_long = 1;
                int signe_lat = 1;
                if (long_degre < 0) {
                        signe_long = -1;
                }
                if (lat_degre < 0) {
                        signe_lat = -1;
                }

                _long_degre = long_degre;
                _long_minute = long_minute;
                _long_seconde = long_seconde;
                _lat_degre = lat_degre;
                _lat_minute = lat_minute;
                _lat_seconde = lat_seconde;
                _longitude = (Math.abs(_long_degre) +
                        (double)(_long_minute) / 60.0d +
                        (double)(_long_seconde) / 3600.0d) * signe_long;
                _latitude = (Math.abs(_lat_degre) +
                        (double)(_lat_minute) / 60.0d +
                        (double)(_lat_seconde) / 3600.0d) * signe_lat;
                //System.out.println(this.toString());
        }
        /**
        * constructeur avec degr decimale
        * @param= longitude
        * @param=latitude
        **/

        public coord(double longitude, double latitude) {
                _longitude = longitude;
                _latitude = latitude;

                _long_degre = new Double(longitude).intValue();
                _lat_degre = new Double(latitude).intValue();

                double tmp = (_longitude -
                        new Integer(_long_degre).doubleValue()) * 60.0d;
                _long_minute = new Double(tmp).intValue();
                tmp = (tmp - new Integer(_long_minute).doubleValue()) *
                        60.0d;
                ;
                _long_seconde = Math.abs(new Double(tmp).intValue());
                _long_minute = Math.abs(_long_minute);

                tmp = (_latitude -
                        new Integer(_lat_degre).doubleValue()) * 60.0d;
                _lat_minute = new Double(tmp).intValue();
                tmp = (tmp - new Integer(_lat_minute).doubleValue()) *
                        60.0d;
                ;
                _lat_seconde = Math.abs(new Double(tmp).intValue());
                _lat_minute = Math.abs(_lat_minute);
                System.out.println(this.toString());
        }
        /**
        * affichage dans les deux modes
        * @return= String Chaine de caracteres.
        */

        public String toString() {
                return ("Longitude :" + _longitude + "Latitude :" +
                        _latitude + "\n" +"Longitude : " +
                        _long_degre + ""+_long_minute + "\'"+
                        _long_seconde + "\'\'" +"Latitude : " +
                        _lat_degre + ""+_lat_minute + "\'"+
                        _lat_seconde + "\'\'");

        }
}

